using UnityEditor;
using UnityEngine;
using UnityEngine.UIElements;

public class PlaymodeControls : EditorWindow {
    [MenuItem("Window/DialogueBox")]
    public static void ShowExample() {
        PlaymodeControls wnd = GetWindow<PlaymodeControls>();
        wnd.titleContent = new GUIContent("DialogueBox");
    }

    private int ButtonCount = 0;

    public void OnEnable() {
    VisualElement root = rootVisualElement;
    var visualTree = AssetDatabase.LoadAssetAtPath<VisualTreeAsset>("Assets/UI/Dialogue Box/Dialogue Box.uxml");
    var styleSheet = AssetDatabase.LoadAssetAtPath<StyleSheet>("Assets/UI/Dialogue Box/Dialogue Box.uss");
    VisualElement tree = visualTree.CloneTree();
    tree.styleSheets.Add(styleSheet);
    root.Add(tree);

    ButtonCount = 0;
    root.Q<TextElement>("Dialogue").text = "Test Test Test";

    root.Q<Button>("Button1").visible = false;
    root.Q<Button>("Button2").visible = false;
    root.Q<Button>("Button3").visible = false;
    root.Q<Button>("Button4").visible = false;

    root.Q<Image>("PlayIcon").image = EditorGUIUtility.IconContent("PlayButton").image;
    root.Q<Image>("PlusIcon").image = EditorGUIUtility.IconContent("Toolbar Plus").image;
    root.Q<Image>("MinusIcon").image = EditorGUIUtility.IconContent("Toolbar Minus").image;

    root.Q<Button>("PlayButton").RegisterCallback<MouseUpEvent>((e) => {
        root.Q<TextElement>("Dialogue").text = "Text hat sich verändert!";;
    });

    root.Q<Button>("Button1").RegisterCallback<MouseUpEvent>((e) => {
        root.Q<TextElement>("Dialogue").text = "Text hat sich nochmal verändert!";;
    });

    root.Q<Button>("Button2").RegisterCallback<MouseUpEvent>((e) => {
        root.Q<TextElement>("Dialogue").text = "Text hat sich wieder verändert!";;
    });

    root.Q<Button>("Button3").RegisterCallback<MouseUpEvent>((e) => {
        root.Q<TextElement>("Dialogue").text = "Text hat sich nicht verändert!";;
    });

    root.Q<Button>("Button4").RegisterCallback<MouseUpEvent>((e) => {
        root.Q<TextElement>("Dialogue").text = "Test Test Test";;
    });

    root.Q<Button>("MoreButtons").RegisterCallback<MouseUpEvent>((e) => {
        if (ButtonCount<4){ButtonCount++;};
        
        switch(ButtonCount) {
            case 1: root.Q<Button>("Button4").visible = true; break;
            case 2: root.Q<Button>("Button3").visible = true; break;
            case 3: root.Q<Button>("Button2").visible = true; break;
            case 4: root.Q<Button>("Button1").visible = true; break;
        }
    });

    root.Q<Button>("LessButtons").RegisterCallback<MouseUpEvent>((e) => {
        if (ButtonCount>0){ButtonCount--;};

        switch(ButtonCount) {
            case 0: root.Q<Button>("Button4").visible = false; break;
            case 1: root.Q<Button>("Button3").visible = false; break;
            case 2: root.Q<Button>("Button2").visible = false; break;
            case 3: root.Q<Button>("Button1").visible = false; break;
        }
    });
;

    }
}



